Unit JANELA;

Interface

{$M 10000,0,10000}

Uses Crt, Dos;

Type

  PONTEIRO_PARA_JANELA = ^NO_DADOS;

  NO_DADOS = Record
               A,
               B,
               C,
               D,
               INDICE:Integer;
               DADOS : Array [1..100] of Word;
               PROXIMO : PONTEIRO_PARA_JANELA
             End;

Procedure
 SALVE_JANELA (Y1,X1,Y2,X2:Integer;Var FIM_PILHA:PONTEIRO_PARA_JANELA);
Procedure
 FECHE_JANELA (Var FIM_PILHA: PONTEIRO_PARA_JANELA);
Procedure
 MOLDURA (Y1,X1,Y2,X2,TIPO:Integer);
Procedure
 ANIME_JANELA (Y1,X1,Y2,X2,PONTO_Y,PONTO_X,COR,SOMBRA:Integer);

Implementation

Procedure
   SALVE_JANELA (Y1,X1,Y2,X2:Integer;Var FIM_PILHA:PONTEIRO_PARA_JANELA);

Var

  MATRIZ: Array [1..25,1..80] of Word Absolute $B000:$8000;

  INDICE,
  LINHA,
  COLUNA : Integer;

  PONTA: PONTEIRO_PARA_JANELA;

Begin
  New (PONTA);
  PONTA^.PROXIMO:=FIM_PILHA;
  FIM_PILHA:=PONTA;
  INDICE:=0;
  For LINHA:=X1 To X2 Do
    For COLUNA:=Y1 To Y2 Do
      Begin
        Inc (INDICE);
        FIM_PILHA^.DADOS[INDICE]:=MATRIZ [COLUNA,LINHA];
        If INDICE=100
          Then
            Begin
              PONTA:=FIM_PILHA;
              New (FIM_PILHA);
              FIM_PILHA^.PROXIMO:=PONTA;
              PONTA:=Nil;
              INDICE:=0
            End
      End;
  FIM_PILHA^.INDICE:=INDICE;
  FIM_PILHA^.A:=X1;
  FIM_PILHA^.B:=Y1;
  FIM_PILHA^.C:=X2;
  FIM_PILHA^.D:=Y2
End;

Procedure FECHE_JANELA (Var FIM_PILHA: PONTEIRO_PARA_JANELA);

Var

  MATRIZ: Array [1..25,1..80] of Word Absolute $B000:$8000;

  A1,
  A2,
  A3,
  A4,
  INDICE,
  LINHA,
  COLUNA: Integer;

  AUXILIAR: PONTEIRO_PARA_JANELA;

Begin
  A1:=FIM_PILHA^.A;
  A2:=FIM_PILHA^.B;
  A3:=FIM_PILHA^.C;
  A4:=FIM_PILHA^.D;
  INDICE:=FIM_PILHA^.INDICE;
  If FIM_PILHA^.INDICE=0
    Then
      Begin
        AUXILIAR:=FIM_PILHA;
        FIM_PILHA:=FIM_PILHA^.PROXIMO;
        INDICE:=100;
        Dispose (AUXILIAR)
      End;
  For LINHA:=A3 Downto A1 Do
    For COLUNA:=A4 Downto A2 Do
      Begin
        MATRIZ[COLUNA,LINHA]:=FIM_PILHA^.DADOS [INDICE];
        Dec (INDICE);
        If INDICE=0
          Then
            Begin
              AUXILIAR:=FIM_PILHA;
              FIM_PILHA:=FIM_PILHA^.PROXIMO;
              INDICE:=100;
              Dispose (AUXILIAR)
            End
    End
End;

Procedure MOLDURA (Y1,X1,Y2,X2,TIPO:Integer);

Var

  I: Integer;

Begin
  Window (1,1,80,25);
  HighVideo;
  GotoXY (X1,Y1);
  Case TIPO of
    1 : Write (#201);
    2 : Write (#177);
    3 : Write (#214);
    4 : Write (#213);
    5 : Write (#176);
    6 : Write (#042);
    7 : Write (#178);
    8 : Write (#219)
  End;
  GotoXY (X2,Y1);
  Case TIPO of
    1 : Write (#187);
    2 : Write (#177);
    3 : Write (#183);
    4 : Write (#184);
    5 : Write (#176);
    6 : Write (#042);
    7 : Write (#178);
    8 : Write (#219)
  End;
  GotoXY (X1,Y2);
  Case TIPO of
    1 : Write (#200);
    2 : Write (#177);
    3 : Write (#211);
    4 : Write (#212);
    5 : Write (#176);
    6 : Write (#042);
    7 : Write (#178);
    8 : Write (#219)
  End;
  GotoXY (X2,Y2);
  Case TIPO of
    1 : Write (#188);
    2 : Write (#177);
    3 : Write (#189);
    4 : Write (#190);
    5 : Write (#176);
    6 : Write (#042);
    7 : Write (#178);
    8 : Write (#219)
  End;
  For I:=(X1+1) To (X2-1) Do
    Begin
      GotoXY (I,Y1);
      Case TIPO of
        1 : Write (#205);
        2 : Write (#177);
        3 : Write (#196);
        4 : Write (#205);
        5 : Write (#176);
        6 : Write (#042);
        7 : Write (#178);
        8 : Write (#219)
      End;
      Gotoxy (I,Y2);
      Case TIPO of
        1 : Write (#205);
        2 : Write (#177);
        3 : Write (#196);
        4 : Write (#205);
        5 : Write (#176);
        6 : Write (#042);
        7 : Write (#178);
        8 : Write (#219)
      End;
    End;
  For I:=(Y1+1) To (Y2-1) Do
    Begin
      Gotoxy (X1,I);
      Case TIPO of
        1 : Write (#186);
        2 : Write (#177);
        3 : Write (#186);
        4 : Write (#179);
        5 : Write (#176);
        6 : Write (#042);
        7 : Write (#178);
        8 : Write (#219)
      End;
      Gotoxy (X2,I);
      Case TIPO of
        1 : Write (#186);
        2 : Write (#177);
        3 : Write (#186);
        4 : Write (#179);
        5 : Write (#176);
        6 : Write (#042);
        7 : Write (#178);
        8 : Write (#219)
      End
    End;
  Window ((X1+1),(Y1+1),(X2-1),(Y2-1));
  NormVideo
End;

Procedure ANIME_JANELA (Y1,X1,Y2,X2,PONTO_Y,PONTO_X,COR,SOMBRA:Integer);

Var

  MATRIZ: Array [1..25,1..80] of Word Absolute $B000:$8000;

  INCREMENTO_X1,
  INCREMENTO_Y1,
  INCREMENTO_X2,
  INCREMENTO_Y2,
  ANIMACAO_X1,
  ANIMACAO_Y1,
  ANIMACAO_X2,
  ANIMACAO_Y2: Real;

  CONTADOR,
  POSICAO: Integer;

Begin
  If SOMBRA<>0
    Then
      Begin
        X2:=X2-1;
        Y2:=Y2-1
      End;
  INCREMENTO_X1:=(PONTO_X - X1)/40;
  INCREMENTO_X2:=(X2 - PONTO_X)/40;
  INCREMENTO_Y1:=(PONTO_Y - Y1)/40;
  INCREMENTO_Y2:=(Y2 - PONTO_Y)/40;
  ANIMACAO_X1:=PONTO_X;
  ANIMACAO_X2:=PONTO_X;
  ANIMACAO_Y1:=PONTO_Y;
  ANIMACAO_Y2:=PONTO_Y;
  For CONTADOR:=1 to 40 do
    Begin
      Window (Round (ANIMACAO_X1),
              Round (ANIMACAO_Y1),
              Round (ANIMACAO_X2),
              Round (ANIMACAO_Y2));
      TextBackGround (COR);
      ClrScr;
      ANIMACAO_X1:=ANIMACAO_X1 - INCREMENTO_X1;
      ANIMACAO_Y1:=ANIMACAO_Y1 - INCREMENTO_Y1;
      ANIMACAO_X2:=ANIMACAO_X2 + INCREMENTO_X2;
      ANIMACAO_Y2:=ANIMACAO_Y2 + INCREMENTO_Y2
    End;
  Window (X1,Y1,X2,Y2);
  If SOMBRA<>0
    Then
      Begin
        For POSICAO:=(X1+1) to (X2+1) do
          MATRIZ [(Y2+1),POSICAO]:=(Lo (MATRIZ [(Y2+1),POSICAO])+3584);
        For POSICAO:=(Y1+1) to (Y2+1) do
          MATRIZ [POSICAO,(X2+1)]:=(Lo (MATRIZ [POSICAO,(X2+1)])+3584);
      End;
  TextBackGround (COR);
  ClrScr
End;

End.