Program Montador_S83;

Uses Crt, Janela;   { As funcoes pertencentes a Janela.Tpu sao:
                      Salve_Janela, Moldura, Feche_Janela,     }

Type LINHA_COMANDO = Record
                      COD_OPE: Byte;            {Codigo do comando       }
                      IND_PRI_OPE: Boolean;     {Existe prim.operando?   }
                      VAL_PRI_OPE: Byte;        {Se sim,Qual o seu valor?}
                      IND_SEG_OPE: Boolean;     {Existe seg.operando?    }
                      VAL_SEG_OPE: Word;        {Se sim,Qual o seu valor?}
                      IND_TAB_SIM: Boolean;     {Tem relacao com um simb?}
                      VAL_TAB_SIM: Word;        {Se sim,Qual o simbolo?  }
                      INCREM: Integer           {Incremento do seg.oper. }
                     End;

     TIPO_ROTULO = Array [1..6] of char;

     TABELA_SIMBOLOS = Record
                        IDENTIF: Word;          {Indice da tabela.       }
                        SIMBOLO: TIPO_ROTULO;   {Indentific.do simbolo.  }
                        VALOR: Integer          {Valor do simbolo.       }
                       End;
 Const

  LINHA_COM1='PARA SOMA SUB  MUL  DIV  DD   DE   CB   CL   E    ';
  LINHA_COM2='OU   OUX  CBT  CPL  CRB  CRP  LMP  ABT  APL  ESC  ';
  LINHA_COM3='LE   D    DSUB RET  CVB  CVD  END  DCNT II   DI   DA   ENDP ';

Var

 LINHA: Array [1 .. 1000] of LINHA_COMANDO;     {Ate mil comandos }
 TABELA: Array [1 .. 1000] of TABELA_SIMBOLOS;  {Ate mil simbolos }

 ARQ: Text;
 NOME_ARQ: String [30];
 OBJ: Text;
 NOME_OBJ: String [30];

 ERRO :Boolean;

 JNL: PONTEIRO_PARA_JANELA;

 X,
 Y: Byte;        {Posicao inicial do cursor.}

 Procedure ENTRA_ARQUIVO (Var ARQ:Text; Var OBJ:Text);

 Var

  NUMERO_PARAMETROS: Byte; {Numero de parametros passados pelo sistema.}
  NOME_ARQ,
  NOME_OBJ: String [30];

  Function EXISTE_ARQUIVO (NOMEARQ: String): Boolean;

  Var

   ARQ: File;

  Begin
   {$I-}
   Assign (ARQ, NOMEARQ);
   Reset (ARQ);
   Close (ARQ);
   {$I+}
   EXISTE_ARQUIVO := (IOResult = 0) and (NOMEARQ <> '')
  End;

 Begin
  NUMERO_PARAMETROS:=ParamCount;
  If (NUMERO_PARAMETROS <> 2)
   Then    {Se parametros invalidos entre arquivos pela janela.}
    Begin
     SALVE_JANELA (1,1,10,50,JNL);
     TextBackGround (9);
     MOLDURA (1,1,10,50,1);
     TextBackGround (9);
     ClrScr;
     WriteLn ('Montador S83 V1.0 17/05/91');
     WriteLn;
     WriteLn ('MONTADOR [FONTE] [OBJETO]');
     WriteLn;
     Repeat
      Write ('Arquivo fonte: ');
      ReadLn (NOME_ARQ);
     Until EXISTE_ARQUIVO (NOME_ARQ);
     Write ('Arquivo objeto:');
     ReadLn (NOME_OBJ);
    FECHE_JANELA (JNL);
    End
   Else
    Begin
     NOME_ARQ:=ParamStr (1);
     If (Not EXISTE_ARQUIVO (NOME_ARQ))
      Then
       Begin
        Write ('ERRO, Nao existe ',NOME_ARQ);
        Halt;
       End;
     NOME_OBJ:=ParamStr (2);
    End;
  Assign (ARQ, NOME_ARQ);
  Reset (ARQ);
  Assign (OBJ, NOME_OBJ);
 End;

 Procedure ZERA_VETORES;

 Begin
  FillChar (LINHA,11000,0);
  FillChar (TABELA,10000,0);
 End;

 Procedure TRADUZA;

  Var

   IND_FON_LIN,
   IND_TAB,
   IND_LIN,
   CONT_PASSO: Integer;
   FIM_TRADUCAO: Boolean;

  Function LE_CARACTER: Char;

   Var

    CARACTER: Char;

   Begin
    If Eof (ARQ)
     Then
      ERRO:=True;
    Read (ARQ, CARACTER);
    If CARACTER <> Chr (26)
     Then
      Write (CARACTER);
    LE_CARACTER:=Caracter;
   End;


  Procedure RECONHECA_START;

   Var

    COMANDO: Array [1..5] of char;
    ESPACO: Char;
    CONTADOR: Byte;

  Begin
   For CONTADOR:=1 to 7 do
    ESPACO:=LE_CARACTER;
   For CONTADOR:=1 to 5 do
    COMANDO [CONTADOR]:=LE_CARACTER;
   Repeat
    ESPACO:=LE_CARACTER;
   Until (ESPACO = Chr (10)) or (ERRO);
   If COMANDO = 'START'
    Then
     ERRO:=False
    Else
     ERRO:=True
  End;

  Procedure RECONHECA_CORPO;

   Var

    ESPACO: Char;

    Procedure TRATE_ROTULO;


    Var

     CONTADOR: Byte;
     ROTULO: TIPO_ROTULO;
     ESPACO: Char;

     Procedure ATUALIZA_ROTULO (ROTULO: TIPO_ROTULO);

     Var

      CONTADOR: Word;

     Begin
      CONTADOR := 1;
      While (CONTADOR<=IND_TAB) and (ROTULO<>TABELA[CONTADOR].SIMBOLO) do
       Inc (CONTADOR);
      If (IND_TAB < CONTADOR)
       Then
        Begin
         Inc (IND_TAB);
         TABELA[IND_TAB].IDENTIF:=IND_TAB;
         TABELA[IND_TAB].SIMBOLO:=ROTULO;
         TABELA[IND_TAB].VALOR:=CONT_PASSO
        End
       Else
         TABELA[CONTADOR].VALOR:=CONT_PASSO;
     End;

    Begin
     For CONTADOR:=1 to 6 do
      ROTULO[CONTADOR]:=LE_CARACTER;
     ESPACO:=LE_CARACTER;
     If ESPACO <> ' '
      Then
       ERRO:=True
      Else
       If ROTULO <> '      '
        Then
         ATUALIZA_ROTULO (ROTULO);
    End;

    Procedure TRATA_COMANDO;

    Var

     COMANDO: Array [1..5] of char;
     COMSRCH: String [5];
     CONTADOR1,
     CONTADOR2: Byte;
     POSICAO: Byte;
     ESPACO: Char;

     Procedure ATUCOM (COD:Byte;POP:Boolean;SOP:Boolean;SIMB:Boolean;INCR:Byte);

      Begin
       Inc (IND_LIN);
       LINHA[IND_LIN].COD_OPE:=COD;
       LINHA[IND_LIN].IND_PRI_OPE:=POP;
       LINHA[IND_LIN].IND_SEG_OPE:=SOP;
       LINHA[IND_LIN].IND_TAB_SIM:=SIMB;
       LINHA[IND_LIN].INCREM:=0;
       Inc (CONT_PASSO, INCR)
      End;

    Begin
     CONTADOR1:=0;
     Repeat
      Inc (CONTADOR1);
      COMANDO[CONTADOR1]:=LE_CARACTER;
     Until (CONTADOR1 = 5) or (COMANDO [CONTADOR1] = Chr (13)) or (ERRO=True);
     If Eof (ARQ)
      Then
       Begin
        ERRO:=False;
        COMANDO[CONTADOR1]:=' ';
       End
      Else
       Begin
        If (COMANDO[CONTADOR1] = Chr (13)) and (ERRO <> True)
         Then
          Begin
           For CONTADOR2:=(CONTADOR1) to 5 do
            COMANDO [CONTADOR2]:=' ';
          End
         Else
          For CONTADOR2:=1 to 3 do
           Begin
            ESPACO:=LE_CARACTER;
            If ESPACO <> ' '
             Then
              ERRO:=True;
           End;
       End;
      COMSRCH:=COMANDO;
      POSICAO:=Pos (COMSRCH, LINHA_COM1);
      If POSICAO = 0
       Then
        Begin
         POSICAO:=Pos (COMSRCH, LINHA_COM2);
         If POSICAO = 0
          Then
           Begin
            POSICAO:=Pos (COMSRCH, LINHA_COM3);
            If POSICAO = 0
             Then
              ERRO:=True
             Else
              POSICAO:=(POSICAO-1) Div 5 + 20
           End
          Else
           POSICAO:=(POSICAO-1) Div 5 + 10
        End
       Else
        POSICAO:=(POSICAO-1) Div 5;
      If Not ERRO
       Then
        Case POSICAO of
         00 : {PARA}  ATUCOM (00,False,False,False,1);
         01 : {SOMA}  ATUCOM (01,True,True,False,3);
         02 : {SUB}   ATUCOM (02,True,True,False,3);
         03 : {MUL}   ATUCOM (03,True,True,False,3);
         04 : {DIV}   ATUCOM (04,True,True,False,3);
         05 : {DD}    ATUCOM (05,True,True,False,3);
         06 : {DE}    ATUCOM (06,True,True,False,3);
         07 : {CB}    ATUCOM (07,False,False,False,1);
         08 : {CL}    ATUCOM (08,True,True,False,3);
         09 : {E}     ATUCOM (09,True,True,False,3);
         10 : {OU}    ATUCOM (10,True,True,False,3);
         11 : {OUX}   ATUCOM (11,True,True,False,3);
         12 : {CBT}   ATUCOM (12,True,True,False,3);
         13 : {CPL}   ATUCOM (13,True,True,False,3);
         14 : {CRB}   ATUCOM (14,True,True,False,3);
         15 : {CRP}   ATUCOM (15,True,True,False,3);
         16 : {LMP}   ATUCOM (16,True,False,False,2);
         17 : {ABT}   ATUCOM (17,True,True,False,3);
         18 : {APL}   ATUCOM (18,True,True,False,3);
         19 : {ESC}   ATUCOM (19,True,True,False,3);
         20 : {LE}    ATUCOM (20,True,True,False,3);
         21 : {D}     ATUCOM (21,True,True,False,3);
         22 : {DSUB}  ATUCOM (22,True,True,False,3);
         23 : {RET}   ATUCOM (23,True,False,False,2);
         24 : {CVB}   ATUCOM (24,True,True,False,3);
         25 : {CVD}   ATUCOM (25,True,True,False,3);
         26 : {END}   ATUCOM (26,True,True,False,3);
         27 : {DCNT}  ATUCOM (27,True,True,False,3);
         28 : {II}    ATUCOM (28,False,False,False,1);
         29 : {DI}    ATUCOM (29,False,False,False,1);
         30 : {DA}    ATUCOM (30,False,True,False,0);
         31 : {ENDP}  Begin
                       ATUCOM (99,False,False,False,0);
                       FIM_TRADUCAO:=True;
                      End
        End;
    End;

    Procedure TRATE_PRI_OPE;

    Var

     REGISTR: Array [1..3] of char;
     CONTADOR: Byte;
     PRI_OPE:Byte;
     ESPACO: Char;

    Begin
     REGISTR[1]:=LE_CARACTER;
      If Not ERRO
       Then
        Begin
         If REGISTR[1]='R'
          Then
           Begin
            REGISTR[2]:=LE_CARACTER;
            LINHA[IND_LIN].VAL_PRI_OPE:=Ord (REGISTR[2]) - 48;
            ESPACO:=LE_CARACTER;
            If ESPACO <> ','
             Then
              Repeat
               ESPACO:=LE_CARACTER;
              Until (ESPACO = Chr (10)) or (ERRO);
           End
          Else
           Begin
            If (REGISTR[1]<>'1') and (REGISTR[1]<>'0')
             Then
              ERRO:=True
             Else
              Begin
               For CONTADOR:=2 to 3 do
                REGISTR[CONTADOR]:=LE_CARACTER;
               PRI_OPE:=0;
               Inc (PRI_OPE,((Ord (REGISTR[1])-48)*2*2));
               Inc (PRI_OPE,((Ord (REGISTR[2])-48)*2));
               Inc (PRI_OPE,(Ord (REGISTR[3])-48));
               LINHA[IND_LIN].VAL_PRI_OPE:=PRI_OPE;
               ESPACO:=LE_CARACTER;
              End;
           End;
        End;
    End;

    Procedure TRATE_SEG_OPE;

    Var

     SEG_OPE_PROC: Array [1..100] of Char;
     SEG_OPE: TIPO_ROTULO;
     CONTADOR,
     CONTAUX,
     ULTIMO_LIDO: Byte;
     CASA_DEC: Word;
     VALOR: Word;
     ESPACO:Char;
     SINAL: Integer;

     Procedure LE_NUMERO;

      Begin
        Repeat
         Inc (CONTADOR);
         SEG_OPE[CONTADOR]:=LE_CARACTER;
        Until (SEG_OPE[CONTADOR] < '0') or
              (SEG_OPE[CONTADOR] > '9') or (ERRO);
       ULTIMO_LIDO:=CONTADOR;
       CASA_DEC:=1;
       VALOR:=0;
       If Not ERRO
        Then
         While (CONTADOR > 1) do
          Begin
           Dec (CONTADOR);
           Inc (VALOR, (Ord (SEG_OPE[CONTADOR])-48)*CASA_DEC);
           CASA_DEC:=CASA_DEC*10;
          End;
      End;

    Begin
     CONTADOR:=1;
     SEG_OPE_PROC[CONTADOR]:=LE_CARACTER;
     If Not ERRO
      Then
       Begin
        If (SEG_OPE_PROC[CONTADOR] >= '0') and
           (SEG_OPE_PROC[CONTADOR] <= '9')
         Then
          Begin
           SEG_OPE[1]:=SEG_OPE_PROC[1];
           LE_NUMERO;
           If Not ERRO
            Then
             Begin
              LINHA[IND_LIN].VAL_SEG_OPE:=VALOR;
              If LINHA[IND_LIN].COD_OPE = 30
               Then
                Inc (CONT_PASSO, VALOR);
             End;
          End
         Else
          Begin
           While ((SEG_OPE_PROC[CONTADOR] >= 'A') and
                  (SEG_OPE_PROC[CONTADOR] <= 'Z')) or
                 ((SEG_OPE_PROC[CONTADOR] >= '0') and
                  (SEG_OPE_PROC[CONTADOR] <= '9')) or (ERRO) do
            Begin
             Inc (CONTADOR);
             SEG_OPE_PROC[CONTADOR]:=LE_CARACTER;
            End;
           ULTIMO_LIDO:=CONTADOR;
           For CONTAUX:=1 to (CONTADOR -1) do
            SEG_OPE[CONTAUX]:=SEG_OPE_PROC[CONTAUX];
           For CONTAUX:=(CONTADOR) to 6 do
             SEG_OPE[CONTAUX]:=' ';
           CONTADOR:=1;
           While (CONTADOR<=IND_TAB) and
                 (TABELA[CONTADOR].SIMBOLO<>SEG_OPE) do
            Inc (CONTADOR);
           If (TABELA[CONTADOR].SIMBOLO <> SEG_OPE)
            Then
             Begin
              Inc (IND_TAB);
              TABELA[CONTADOR].SIMBOLO:=SEG_OPE;
              TABELA[CONTADOR].IDENTIF:=CONTADOR;
              TABELA[CONTADOR].VALOR:=0;
             End;
           LINHA[IND_LIN].IND_TAB_SIM:=True;
           LINHA[IND_LIN].VAL_TAB_SIM:=CONTADOR;
           If (SEG_OPE_PROC[ULTIMO_LIDO] = '+') or
              (SEG_OPE_PROC[ULTIMO_LIDO] = '-')
            Then
             Begin
              If (SEG_OPE_PROC[ULTIMO_LIDO] = '+')
               Then
                SINAL:=1
               Else
                SINAL:=-1;
              CONTADOR:=1;
              SEG_OPE[CONTADOR]:=LE_CARACTER;
              LE_NUMERO;
              LINHA[IND_LIN].INCREM:=(VALOR*SINAL);
             End;
          End;
        Repeat
         ESPACO:=LE_CARACTER;
        Until (ESPACO = Chr (10)) or (ERRO);
       End;
    End;

  Begin
   While (Not FIM_TRADUCAO) and (Not ERRO) do
    Begin
     Inc (IND_FON_LIN);
     Write (IND_FON_LIN:3,' ');
     TRATE_ROTULO;
     TRATA_COMANDO;
     If LINHA[IND_LIN].IND_PRI_OPE
      Then
        TRATE_PRI_OPE;
     If LINHA[IND_LIN].IND_SEG_OPE
      Then
       TRATE_SEG_OPE;
     If (Not LINHA[IND_LIN].IND_PRI_OPE) And
        (Not LINHA[IND_LIN].IND_SEG_OPE)
      Then
       If FIM_TRADUCAO
        Then
         Begin
          Repeat
           ESPACO:=LE_CARACTER;
          Until ERRO;
          ERRO:=False;
         End
        Else
          Repeat
           ESPACO:=LE_CARACTER;
          Until (ESPACO = Chr (10)) or (ERRO);
    End;
  End;

 Begin
  ClrScr;
  ERRO:=False;
  CONT_PASSO:=0;
  IND_LIN:=0;
  IND_TAB:=0;
  IND_FON_LIN:=1;
  FIM_TRADUCAO:=False;
  Write ('  1 ');
  RECONHECA_START;
  If Not ERRO
   Then
    RECONHECA_CORPO;
  If ERRO
   Then
    Begin
     WriteLn;
     WriteLn ('<ERRO DE TRADUCAO>.');
     WriteLn ('Por favor, revise as ultimas linhas compiladas. ');
     ReadLn
    End
   Else
    Begin
     WriteLn;
     WriteLn ('<COMPILACAO EXECUTADA COM SUCESSO>');
     WriteLn ('Tecla <Enter> para continuar.');
     ReadLn
    End;
 End;

 Procedure GERE_OBJETO;


 Type

  STRHEXA = Array [1..2] of char;

 Var

  CONTAUX,
  CONTADOR: Word;  {Contadores internos}

  HLINHA: Byte;    {Contador do numero de bytes hexadecimais em uma linha.}
  ENDERECO: Word;  {Endereco de cada byte.}

  PRIB,
  SEGB,
  TERB: Byte;      {Valor dos Bytes.}

  VALHEXADEC: STRHEXA; {Contera o byte em hexadecimal da variavel valor.}
  VALOR: Byte;         {Um valor para ser transformado em heza.}

  Procedure HEXA (VALOR: Byte; Var RESULTHEXA: STRHEXA);

  Const

   HEXACODIG: Array [0 .. 15] of Char = '0123456789ABCDEF';

  Begin
   RESULTHEXA [1]:=HEXACODIG [VALOR Div 16];
   RESULTHEXA [2]:=HEXACODIG [VALOR and 15]
  End;


  Procedure COLOQUE_HEXA (VALOR: Byte); {Coloca um hexa no arquivo objeto.}

   Procedure PONHA_ENDERECO (ENDERECO: Word);

   Var

    ENDBYTE: Byte;

   Begin
    ENDBYTE:=Hi (ENDERECO);
    HEXA (ENDBYTE,VALHEXADEC);
    Write (OBJ,VALHEXADEC);
    ENDBYTE:=Lo (ENDERECO);
    HEXA (ENDBYTE,VALHEXADEC);
    Write (OBJ,VALHEXADEC);
   End;

  Begin
   If HLINHA=0
    Then
     PONHA_ENDERECO (ENDERECO);
   Write (OBJ,' ');
   HEXA (VALOR,VALHEXADEC);
   Write (OBJ,VALHEXADEC);
   Inc (HLINHA);
   Inc (ENDERECO);
   If HLinha=20
    Then
     Begin  {Fim de uma linha do arquivo objeto.}
      Write (OBJ,Chr(13)); {Enter}
      Write (OBJ,Chr(10)); {Proxima linha}
      HLinha:=0;
     End;
  End;

 Begin
  Rewrite (OBJ);
  WriteLn;
  Write ('   Endereco de carga: ');
  ReadLn (ENDERECO);
  For CONTADOR:=1 to 4 do   {Primeiro endereco.}
   Write (OBJ,'0');
  Write (OBJ,' ');
  VALOR:=Hi (ENDERECO);     {Endereco de carga (Primeira palavra.)}
  HEXA (VALOR,VALHEXADEC);
  Write (OBJ,VALHEXADEC);
  Write (OBJ,' ');
  VALOR:=Lo (ENDERECO);
  HEXA (VALOR,VALHEXADEC);
  Write (OBJ,VALHEXADEC);
  Write (OBJ,Chr(13));
  Write (OBJ,Chr(10));
  CONTADOR:=1;
  HLINHA:=0;
  While LINHA[CONTADOR].COD_OPE <> 99 do
   Begin
    If LINHA[CONTADOR].COD_OPE = 30
     Then         {Gera espaco no objeto.}
      For CONTAUX:=1 to LINHA[CONTADOR].VAL_SEG_OPE do
       COLOQUE_HEXA (0)
     Else
      Begin
       PRIB:=LINHA[CONTADOR].COD_OPE*4;
       If LINHA[CONTADOR].IND_PRI_OPE
        Then
         Begin
          Inc (PRIB, (LINHA[CONTADOR].VAL_PRI_OPE DIV 2));
          SEGB:=(LINHA[CONTADOR].VAL_PRI_OPE AND 1)*128;
          If LINHA[CONTADOR].IND_SEG_OPE
           Then
            Begin
             If LINHA[CONTADOR].IND_TAB_SIM
              Then
               LINHA[CONTADOR].VAL_SEG_OPE:=
               TABELA[LINHA[CONTADOR].VAL_TAB_SIM].VALOR
               +LINHA[CONTADOR].INCREM
              Else
               Inc (LINHA[CONTADOR].VAL_SEG_OPE,LINHA[CONTADOR].INCREM);
             Inc (SEGB,Hi(LINHA[CONTADOR].VAL_SEG_OPE) and 127);
             TERB:=Lo (LINHA[CONTADOR].VAL_SEG_OPE);
             COLOQUE_HEXA (PRIB);
             COLOQUE_HEXA (SEGB);
             COLOQUE_HEXA (TERB);
            End
           Else
            Begin
             COLOQUE_HEXA (PRIB);
             COLOQUE_HEXA (SEGB);
            End
         End
       Else
        COLOQUE_HEXA (PRIB)
      End;
    Inc (contador)
   End
 End;

Begin
 X:=WhereX;
 Y:=WhereY;

 ENTRA_ARQUIVO (ARQ, OBJ);

 SALVE_JANELA (1,5,25,75,JNL);
 TextBackGround (9);
 MOLDURA (1,5,25,75,1);
 TextBackGround (9);
 ClrScr;

 ZERA_VETORES;

 TRADUZA;

 If Not ERRO
  Then
   Begin
    SALVE_JANELA (7,7,11,73,JNL);
    TextBackGround (4);
    MOLDURA (7,7,11,73,1);
    TextBackGround (4);
    ClrScr;

    GERE_OBJETO;

    Close (OBJ);
    FECHE_JANELA (JNL);
   End;
 FECHE_JANELA (JNL);
 Close (ARQ);
 Window (1,1,80,25);
 TextBackGround (0);
 GotoXY (X, Y)
End.

